# This script is not intended to be executed directly.  It is sourced by test-runner.sh and most functions you see here are defined in test-tools.sh
# The variables EXENAME, EXEBASE, OKDIR, and EXEDIR are defined externally.

beginTestBlock  # Begin a group of tests.
runMake -r @EXE  # run `make` for the main exe and any other listed programs

initTest 'general_test'
CONF="${TEST}_config.conf"

# Test dynalign with the general self-contained example given.
TEXT=\
'inseq1 = testFiles/testFile_RD0260.seq
inseq2 = testFiles/testFile_RD0500.seq
outct = @TEST_seq1.ct
outct2 = @TEST_seq2.ct
aout = @TEST_alignment.ali'

echo "${TEXT//'@TEST'/$TEST}" > "$CONF"
[[ $SMP ]] &&  echo "num_processors = 2" >> "$CONF"

runTest @EXE "$CONF"
runDiff @TEST_seq1.ct @OKBASE_seq1_OK.ct  'seq1'
runDiff @TEST_seq2.ct @OKBASE_seq2_OK.ct  'seq2'
runDiff @TEST_alignment.ali @OKBASE_alignment_OK.ali  'ali'
rm -f "$CONF"; endTest

endTestBlock # End a group of tests. Also cleans up orphaned files etc.
